'based on ' mouse.bas' by  Don (don67geo@yahoo.com) 
'  modified and translated opengl mouse.c into hotbasic source. 
' 
$typecheck ON
$INCLUDE <RapidQ2.inc>
$INCLUDE <GL\QGL.inc>
$RESOURCE ICO_CARN AS "E:\CARN2\CARN2.ICO"
CONST NL=CHR$(10)

Declare Sub FBDrawPic3D Lib "FBRandomMapFuncs" Alias "FBDrawPic3D@24" (Z As INTEGER, ByVal MaxX As Integer, ByVal MaxY As Integer, ByVal MaxZ AS Integer, ByVal NDM As INTEGER, ByVal K AS SINGLE)
Declare Sub FBMoveSeaLevel Lib "FBRandomMapFuncs" Alias "FBMoveSeaLevel@20" (W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal NDM AS Integer)
Declare Sub FBInvertHeightMap Lib "FBRandomMapFuncs" Alias "FBInvertHeightMap@28" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBSwapRows Lib "FBRandomMapFuncs" Alias "FBSwapRows@12" (A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer)
Declare Sub FBProcessAfterLoad Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoad@20" (Z AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer)
Declare Sub FBProcessAfterLoadBMP Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoadBMP@28" (Z AS INTEGER, A AS INTEGER, W AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBGenRandom Lib "FBRandomMapFuncs" Alias "FBGenRandom@28" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBDrawPicture Lib "FB2DMaps" Alias "FBDrawPicture@24" (BitMap As Integer, Matrix As Integer, ByVal Size As Integer, ByVal Typ As Integer, ByVal BITS As Integer, ByVal NDM As Integer)

DECLARE SUB FormCreate
DECLARE SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER)
DECLARE SUB FormMouseDown (Button%, X%, Y%, Shift%)
DECLARE SUB FormMouseMove (X%, Y%, Shift%)
DECLARE SUB FormMouseUp(Button%, X%, Y%, Shift%)
DECLARE SUB FormSize
DECLARE sub meshbuilder
DECLARE sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
DECLARE sub setrendermode
DECLARE sub setvisual(iw as integer, ih as integer)

DECLARE sub GenerateTerrain
DIM meshList as glInt

$define PAN    1
$define ROTATE 2
$define ZOOM   3
$define MaxX    512
$define MaxY    512
$define MaxZ    512
defint mx,my,dx,dy
dim trans(3) as single
dim rotat(2) as single

'DIM HeightMap?(MaxX-1,MaxY-1)
'DIM W?(MaxX-1,MaxY-1)
DIM Z%(MaxX*2,MaxY*2)

 DIM X AS glInt
 DIM Y AS glInt
 DIM R0 AS glInt
 DIM R1 AS glInt
 DIM R2 AS glInt
 DIM R3 AS glInt
 DIM R4 AS glInt
' DIM A%(MaxX, MaxY)
 DEFINT D,M,N,R,S,T,H,V,K
 DEFSNG ROJO,VERDE,AZUL
' $typecheck OFF

DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadMapFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture
DECLARE SUB DrawPicture3D
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB Render3D
DECLARE SUB RenderHeightMap
DECLARE SUB RenderTextures1
DECLARE SUB RenderTextures2
DECLARE SUB RenderObjects
DECLARE SUB RenderFlags
DECLARE SUB RenderFlags2
DECLARE SUB RenderLightMap
DECLARE SUB RenderLightMap1
DECLARE SUB RenderLightMap2
DECLARE SUB RenderLightMap3
DECLARE SUB RenderWater
DECLARE SUB RenderObjHeights
DECLARE SUB RenderFog
DECLARE SUB RenderSounds

DECLARE SUB MoveSeaLevel
DECLARE SUB InvertHeightMap
DECLARE SUB ExportBitMap
DECLARE SUB ImportBitMap
DECLARE SUB LoadBitMap
DECLARE SUB SaveBitMap
DECLARE SUB SwapRows
DECLARE SUB SeaLevelChange
DECLARE SUB OpenSeaForm
DECLARE SUB CloseSeaForm

DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)

DECLARE SUB ExportBMPgrey
DECLARE SUB ImportBMPgrey
DECLARE SUB LoadBMPgrey
DECLARE SUB SaveBMPgrey

DIM SaveDialog AS QFileDialog
DIM MustWidth% AS INTEGER
DIM MustHeight% AS INTEGER
DIM TextureSize AS INTEGER
 
DIM BitMap AS QBITMAPEX
    BitMap.Width = 1024 ' 2048
    BitMap.Height = 768 ' 1536
    BitMap.PixelFormat = pf32bit
    BitMap.Paint(0,0,0,0)    

DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM FileType AS SHORT

' DIM HeightMap?(511,511)
DIM Textures1?(511,511)
DIM Textures2?(511,511)
' DIM Objects?(511,511)
DIM Flags?(511,511)
DIM LightMap?(511,511)
' DIM Water?(511,511)
' DIM ObjHeight?(511,511)
' DIM Fog?(255,255)
' DIM Sound?(255,255)

DIM HeightMap?(1023,1023)
DIM Textures1%(1023,1023)
DIM Textures2%(1023,1023)
DIM Objects?(1023,1023)
DIM Flags%(1023,1023)
DIM LightMap1?(1023,1023)
DIM LightMap2?(1023,1023)
DIM LightMap3?(1023,1023)
DIM Water?(1023,1023)
DIM ObjHeight?(1023,1023)
DIM Fog?(511,511)
DIM Sound?(511,511)


DIM FileName$ as String
DIM Q AS SHORT
DIM Z AS SHORT
DIM YY AS SHORT
'DIM ROJO AS BYTE
'DIM VERDE AS BYTE
'DIM AZUL AS BYTE
DIM NDM AS BYTE
NDM = 0
DIM SeaLevel AS BYTE

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM SaveArrayAsBMPgrey AS QMenuItem
    SaveArrayAsBMPgrey.Caption = "Export as &BMP"
    SaveArrayAsBMPgrey.OnClick = ExportBMPgrey
    SaveArrayAsBMPgrey.Enabled=True

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, ExitPrg
 
DIM Map3DMenu AS QMenuItem
    Map3DMenu.Caption = "&3-D Surfaces"
    Map3DMenu.OnClick = Render3D

DIM HeightMapMenu AS QMenuItem
    HeightMapMenu.Caption = "&Heightmap"
    HeightMapMenu.OnClick = RenderHeightMap
        
DIM TextureMap1Menu AS QMenuItem
    TextureMap1Menu.Caption = "Textures&1"
    TextureMap1Menu.OnClick = RenderTextures1
    
DIM TextureMap2Menu AS QMenuItem
    TextureMap2Menu.Caption = "Textures&2"
    TextureMap2Menu.OnClick = RenderTextures2
    
DIM ObjectsMapMenu AS QMenuItem
    ObjectsMapMenu.Caption = "&Objects"
    ObjectsMapMenu.OnClick = RenderObjects
    
DIM FlagsMapMenu AS QMenuItem
    FlagsMapMenu.Caption = "F&lags"
    FlagsMapMenu.OnClick = RenderFlags
    
DIM LightMapMenu AS QMenuItem
    LightMapMenu.Caption = "&LightMap"
    LightMapMenu.OnClick = RenderLightMap
    
DIM LightMap1Menu AS QMenuItem
    LightMap1Menu.Caption = "Da&wn Shadows"
    LightMap1Menu.OnClick = RenderLightMap1
    
DIM LightMap2Menu AS QMenuItem
    LightMap2Menu.Caption = "Da&y Shadows"
    LightMap2Menu.OnClick = RenderLightMap2
    
DIM LightMap3Menu AS QMenuItem
    LightMap3Menu.Caption = "Ni&ght Shadows"
    LightMap3Menu.OnClick = RenderLightMap3
    
DIM WaterMapMenu AS QMenuItem
    WaterMapMenu.Caption = "&Water"
    WaterMapMenu.OnClick = RenderWater
    
DIM ObjHMapMenu AS QMenuItem
    ObjHMapMenu.Caption = "Object heigh&ts"
    ObjHMapMenu.OnClick = RenderObjHeights
    
DIM FogMapMenu AS QMenuItem
    FogMapMenu.Caption = "&Fog"
    FogMapMenu.OnClick = RenderFog
    
DIM SoundsMapMenu AS QMenuItem
    SoundsMapMenu.Caption = "So&unds"
    SoundsMapMenu.OnClick = RenderSounds
    
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.AddItems Map3DMenu, HeightMapMenu, TextureMap1Menu, TextureMap2Menu, ObjectsMapMenu, FlagsMapMenu, LightMapMenu, LightMap1Menu, LightMap2Menu, LightMap3Menu, WaterMapMenu, ObjHMapMenu, FogMapMenu, SoundsMapMenu
    ShowMenu.Enabled=False

DEFINT state = 0
DIM GL AS QGL
'-- user interface here 
create Form as QFORM
  caption       = "3D View"
  center
  width         = 1024
  height        = 768
  onpaint       = meshbuilder
  onmouseup     = FormMouseUp
  onmousedown   = FormMouseDown
  onmousemove   = FormMouseMove
'  onshow        = FormCreate
  onkeydown     = FormKeyDown
  onresize      = FormSize
end create
 FormCreate
' GenerateTerrain
' Form.showmodal
' end

sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
    dx = ox - nx
    dy = ny - oy
    select case state
      case PAN:    trans(0) = trans(0) - dx
                   trans(1) = trans(1) - dy
      case ROTATE: rotat(0) = rotat(0) + (dy * 18.0) / 10.0
                   rotat(1) = rotat(1) - (dx * 18.0) / 10.0
      case ZOOM:   trans(2) = trans(2) - (dx + dy)
    end select
end sub

sub setrendermode
    glEnable(GL_DEPTH_TEST)
'    glEnable(GL_LIGHTING)
'    glEnable(GL_LIGHT0)
end sub

sub setvisual(iw as integer, ih as integer)
    defdbl aspect = iw/ih
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
'    gluPerspective(75.0,aspect,0.1,MAXZ*2.0)
 glOrtho(-Form.width/3,Form.width/3,-Form.height/3,Form.height/3,0.1,3000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glTranslatef(0.0, 0.0, -MaxZ*1.0*FileType)
end sub

sub meshbuilder
    ' rotate a triangle around 
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
'    glLightfv GL_LIGHT0, GL_POSITION, position(0)
    glPushMatrix
    glTranslatef(trans(0), trans(1), trans(2))
        glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)
    glClearColor(0.0,0.0,0.0,0.0)
'    glCallList(meshList)
DIM K AS SINGLE
 K = 0.125

'      glNewList(meshList,GL_COMPILE)
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
        glEnable(GL_CULL_FACE)
        glCullFace (GL_BACK)
'    glBegin(GL_QUADS)
    
FBDrawPic3D(VARPTR(Z%(0,0)),MaxX*FileType,MaxY*FileType,MaxZ*FileType,NDM,K)
'    glEnd
'    glEndList
    glPopMatrix
    GL.Flip
end sub


SUB FormCreate
    GL.Init(Form)
   setrendermode
      meshList=glGenLIsts(1)
END SUB

SUB FormMouseDown (Button%, X%, Y%, Shift%) 
  if Button% = 0 then state = ROTATE  'or state 
  if Button%= 1 then state = PAN 'or state 
'  if Button%= 2 then state = ZOOM 'or state 
  mx = X%'Screen.mouseX 
  my = Y%'Screen.mouseY 
END SUB

SUB FormMouseUp(Button%, X%, Y%, Shift%)
   state = 0
END SUB


SUB FormMouseMove (X%, Y%, Shift%)
     meshframe(state, mx, X%, my, Y%)
     mx = X%
     my = y%
     meshbuilder
     GL.Flip
END SUB

SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER) 
  if key = 27 then
    GL.Close
    Form.close
  end if
'  if KeyShift THEN state = STATE XOR PAN
  SELECT CASE Key
'  CASE 33 ' Page Up
'  state = ZOOM
'  meshframe(state,0,2,0,0)
'     meshbuilder
'  state = 0
'     GL.Flip
'  CASE 34 ' Page Down
'  state = ZOOM
'  meshframe(state,2,0,0,0)
'     meshbuilder
'  state = 0
'     GL.Flip
  CASE 37 ' Left Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 38 ' Up Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,2,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 39 ' Right Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 40 ' Down Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,0,2)
     meshbuilder
  state = 0
     GL.Flip
  CASE ELSE
  state = 0
  meshframe(state,0,0,0,0)
     meshbuilder
     GL.Flip
  END SELECT
END SUB


SUB FormSize
  GL.Resize(form.clientWidth, form.clientHeight)
  setvisual(GL.width, GL.height)
  meshbuilder
END SUB
 
CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 300
    Width = 450
    BorderStyle = 2
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu
END CREATE    
CREATE Canvas AS QCanvas
    Visible = False
    OnMouseMove=CanvasMouseMove
END CREATE
    OnPaint = CanvasPaint
    OnResize = CanvasPaint
    Center
  ShowModal
END CREATE

SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
    Canvas.Hint=""
    IF FileType=1 THEN
    Canvas.Hint=STR$(X)+","+STR$(Y)+NL+"HeightMap:"+STR$(HeightMap?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Textures:"+STR$(Textures1?(Y, X))+","+STR$(Textures2?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Objects:"+STR$(Objects?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Flags:"+STR$(Flags?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"LightMap:"+STR$(LightMap?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Water:"+STR$(Water?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"ObjHeight:"+STR$(ObjHeight?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Fog:"+STR$(Fog?(Y/2, X/2))+NL
    Canvas.Hint=Canvas.Hint+"Sounds:"+STR$(Sound?(Y/2, X/2))
    ELSE
    Canvas.Hint=STR$(X)+","+STR$(Y)+NL+"Height:"+STR$(HeightMap?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Textures:"+STR$(Textures1%(Y, X))+","+STR$(Textures2%(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Objects:"+STR$(Objects?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Flags:"+STR$(Flags%(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"LightMaps:"+STR$(LightMap1?(Y, X))+", "+STR$(LightMap2?(Y, X))+", "+STR$(LightMap3?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Water:"+STR$(Water?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"ObjHeight:"+STR$(ObjHeight?(Y, X))+NL
    Canvas.Hint=Canvas.Hint+"Fog:"+STR$(Fog?(Y/2, X/2))+NL
    Canvas.Hint=Canvas.Hint+"Sounds:"+STR$(Sound?(Y/2, X/2))
    END IF
END SUB      

SUB CanvasPaint
DIM W
DIM H
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)

    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.StretchDraw(RectArea, Bitmap.BMP)
    Canvas.Visible=true
END SUB

SUB FileOpen
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "MAP Files (*.map)|*.map|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Form1.Caption="Viewing "+FileName$
    LoadMapFile
'    ShowMenu.Enabled=True
      END IF
END SUB

     
SUB Render3D

Z=0
YY=0
InitScreen

END SUB

SUB RenderHeightMap

Z=0
YY=1
InitScreen

END SUB

SUB RenderTextures1

Z=1
YY=1
InitScreen

END SUB

SUB RenderTextures2

Z=2
YY=1
InitScreen

END SUB

SUB RenderObjects

Z=3
YY=1
InitScreen

END SUB

SUB RenderFlags

Z=4
YY=1
InitScreen

END SUB

SUB RenderLightMap

Z=5
YY=1
InitScreen

END SUB

SUB RenderWater

Z=6
YY=1
InitScreen

END SUB

SUB RenderObjHeights

Z=7
YY=1
InitScreen

END SUB

SUB RenderFog

Z=8
YY=1
InitScreen

END SUB

SUB RenderSounds

Z=9
YY=1
InitScreen

END SUB

SUB RenderLightMap1

Z=10
YY=1
InitScreen

END SUB

SUB RenderLightMap2

Z=11
YY=1
InitScreen

END SUB

SUB RenderLightMap3

Z=12
YY=1
InitScreen

END SUB


SUB ExitClick
  Form1.Close
END SUB  


SUB LoadMapFile

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
IF File.Size=&H220000 THEN
    FileType=1
ELSE   
    IF File.Size=&HD80000 THEN
        FileType=2
    ELSE
        FileType=0
    END IF
END IF
' PRINT FileType
' IF FileType=0 THEN SHOWMESSAGE "Associated .map file doesn't seem to be a Carnivores file!": GOTO AbortLoadRsc

BitMap.Width=1024*FileType
BitMap.Height=768*FileType

IF FileType=1 THEN
 REDIM HeightMap?(511,511) AS BYTE
 REDIM Objects?(511,511) AS BYTE
 REDIM Water?(511,511) AS BYTE
 REDIM ObjHeight?(511,511) AS BYTE
 REDIM Fog?(255,255) AS BYTE
 REDIM Sound?(255,255) AS BYTE

Form1.Caption="Reading HeightMap Data..."
Form1.Show
File.LoadArray(HeightMap?(0, 0),512*512)
Form1.Caption="Reading Texture Data..."
Form1.Show
File.LoadArray(Textures1?(0, 0),512*512)
Form1.Caption="Reading More Texture Data..."
Form1.Show
File.LoadArray(Textures2?(0, 0),512*512)
Form1.Caption="Reading Objects Data..."
Form1.Show
File.LoadArray(Objects?(0, 0),512*512)
Form1.Caption="Reading Flags Data..."
Form1.Show
File.LoadArray(Flags?(0, 0),512*512)
Form1.Caption="Reading LightMap Data..."
Form1.Show
File.LoadArray(LightMap?(0, 0),512*512)
Form1.Caption="Reading Water Data..."
Form1.Show
File.LoadArray(Water?(0, 0),512*512)
Form1.Caption="Reading Object Heights Data..."
Form1.Show
File.LoadArray(ObjHeight?(0, 0),512*512)
Form1.Caption="Reading Fog Data..."
Form1.Show
File.LoadArray(Fog?(0, 0),256*256)
Form1.Caption="Reading Sound Data..."
Form1.Show
File.LoadArray(Sound?(0, 0),256*256)
FBProcessAfterLoad(VARPTR(Z%(0,0)),VARPTR(HeightMap?(0,0)),MaxX*FileType,MaxY*FileType,MaxZ*FileType)
Form1.Caption="Done"
Form1.Show
ShowMenu.Enabled=True
LightMapMenu.Enabled=True
LightMap1Menu.Enabled=False
LightMap2Menu.Enabled=False
LightMap3Menu.Enabled=False
ELSE
   
    IF FileType=2 THEN
 REDIM HeightMap?(1023,1023) AS BYTE
 REDIM Objects?(1023,1023) AS BYTE
 REDIM Water?(1023,1023) AS BYTE
 REDIM ObjHeight?(1023,1023) AS BYTE
 REDIM Fog?(511,511) AS BYTE
 REDIM Sound?(511,511) AS BYTE

Form1.Caption="Reading HeightMap Data..."
Form1.Show
File.LoadArray(HeightMap?(0, 0),1024*1024)
Form1.Caption="Reading Texture Data..."
Form1.Show
File.LoadArray(Textures1%(0, 0),1024*1024)
Form1.Caption="Reading More Texture Data..."
Form1.Show
File.LoadArray(Textures2%(0, 0),1024*1024)
Form1.Caption="Reading Objects Data..."
Form1.Show
File.LoadArray(Objects?(0, 0),1024*1024)
Form1.Caption="Reading Flags Data..."
Form1.Show
File.LoadArray(Flags%(0, 0),1024*1024)
Form1.Caption="Reading Dawn LightMap Data..."
Form1.Show
File.LoadArray(LightMap1?(0, 0),1024*1024)
Form1.Caption="Reading Day LightMap Data..."
Form1.Show
File.LoadArray(LightMap2?(0, 0),1024*1024)
Form1.Caption="Reading Night LightMap Data..."
Form1.Show
File.LoadArray(LightMap3?(0, 0),1024*1024)
Form1.Caption="Reading Water Data..."
Form1.Show
File.LoadArray(Water?(0, 0),1024*1024)
Form1.Caption="Reading Object Heights Data..."
Form1.Show
File.LoadArray(ObjHeight?(0, 0),1024*1024)
Form1.Caption="Reading Fog Data..."
Form1.Show
File.LoadArray(Fog?(0, 0),512*512)
Form1.Caption="Reading Sound Data..."
Form1.Show
File.LoadArray(Sound?(0, 0),512*512)
FBProcessAfterLoad(VARPTR(Z%(0,0)),VARPTR(HeightMap?(0,0)),MaxX*FileType,MaxY*FileType,MaxZ*FileType)
Form1.Caption="Done"
Form1.Show
ShowMenu.Enabled=True
LightMapMenu.Enabled=False
LightMap1Menu.Enabled=True
LightMap2Menu.Enabled=True
LightMap3Menu.Enabled=True


    ELSE
Form1.Caption="Not a valid Carnivores .map file!"
Form1.Show
    END IF
END IF    
File.Close

END SUB


SUB InitScreen

Canvas.Visible = False

'Form.ClientWidth = 1024
'Form.ClientHeight = 768
'Form1.Width = 1024
'Form1.Height = 768
'Form1.WindowState=2
'Form1.AutoScroll = True

'Canvas.Parent = Form1
'Canvas.Font = Font
'Canvas.Color = 0
'Canvas.OnPaint = DrawPicture

Form1.Color = 0
Form1.Caption="Carnivores 1/2/Ice Age Area Viewer - "+FileName$+" - (C) 2013 by M.A.Ch.F."
'Form1.Onresize = Resize

IF YY=0 THEN DrawPicture3D
IF YY=1 THEN DrawPicture
Form1.Center
Canvas.Visible = True
CanvasPaint
Canvas.ShowHint=True

END SUB


SUB DrawPicture
DIM W AS INTEGER
DIM R AS INTEGER
DIM BITS AS INTEGER, TYP AS INTEGER

IF Z<8 OR Z>9 THEN W=MaxX*FileType ELSE W=MaxX*FileType/2
Form1.ClientWidth = 512*FileType
Form1.ClientHeight = 512*FileType
Canvas.Width = 512*FileType
Canvas.Height = 512*FileType
Canvas.ClientWidth = 512*FileType
Canvas.ClientHeight = 512*FileType
BitMap.Width = W
BitMap.Height = W
BitMap.FillRect(0, 0, 1024, 768, 0)

SELECT CASE Z
CASE 0
R = VARPTR(HeightMap?(0, 0))
BITS = 0
TYP = 1

CASE 1
IF FileType=1 THEN
R = VARPTR(Textures1?(0, 0))
BITS = 1
TYP = 1
ELSE
R = VARPTR(Textures1%(0, 0))
BITS = 1 '2
TYP = 2
END IF

CASE 2
IF FileType=1 THEN
R = VARPTR(Textures2?(0, 0))
BITS = 1
TYP = 1
ELSE
R = VARPTR(Textures2%(0, 0))
BITS = 1 '2
TYP = 2
END IF

CASE 3
R = VARPTR(Objects?(0, 0))
BITS = 1
TYP = 1

CASE 4
IF FileType=1 THEN
R = VARPTR(Flags?(0, 0))
BITS = 1
TYP = 1
ELSE
R = VARPTR(Flags%(0, 0))
BITS = 2
TYP = 2
END IF

CASE 5
R = VARPTR(LightMap?(0, 0))
BITS = -1
TYP = 1

CASE 6
R = VARPTR(Water?(0, 0))
IF FileType=1 THEN BITS = 0 ELSE BITS = 3
TYP = 1

CASE 7
R = VARPTR(ObjHeight?(0, 0))
BITS = 0
TYP = 1

CASE 8
R = VARPTR(Fog?(0, 0))
BITS = 4
TYP = 1

CASE 9
R = VARPTR(Sound?(0, 0))
BITS = 4
TYP = 1

CASE 10
R = VARPTR(LightMap1?(0, 0))
BITS = 0
TYP = 1

CASE 11
R = VARPTR(LightMap2?(0, 0))
BITS = 0
TYP = 1

CASE 12
R = VARPTR(LightMap3?(0, 0))
BITS = 0
TYP = 1


END SELECT

FBDrawPicture(BitMap.Pointer, R, W, TYP, BITS, NDM)
Form1.Show
END SUB


SUB DrawPicture3D
FormSize
Form.ShowModal
END SUB


SUB ExportBMPgrey

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
'    Status1.SimpleText="Exporting "+FileName$
    SaveBMPgrey
  END IF
END SUB

SUB SaveBMPgrey

MustWidth%=512*FileType
MustHeight%=512*FileType
TextureSize=262144*FileType*FileType

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&
DIM Palette&

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
' Status1.SimpleText="Writing Header..."
Form1.Show
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=&H436+TextureSize:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H436:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=MustWidth%:File.Write(BMWidth&)
BMHeight&=MustHeight%:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=8:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H100:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
'BMColorTable$=File.ReadBinStr(1024)
FOR X=0 TO 255
Palette&=X*&H10101
File.Write(Palette&)
NEXT X
' Status1.SimpleText="Writing scanlines..."
Form1.Show

FOR X = 0 TO MustHeight% -1
File.SaveArray(Water?(MustHeight% -1 -X, 0),MustWidth%)
NEXT X

' Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB